import { NgSocialLinksProviderConfig as Config } from '././ng-social-links.types';
import { Providers } from './ng-social-links.constants';
export declare class NgSocialLinksService {
    private document;
    private defaultConfig;
    constructor(document: Document, defaultConfig: Config);
    /**
     * Provides social share URL for a given provider.
     * Addional configuration parameters depend on a chosen provider.
     * @param provider Provider name.
     * @param config Parameters used to build a social share URL.
     */
    getShareLink(provider: typeof Providers.facebook | typeof Providers.reddit | typeof Providers.connectOk, config?: Pick<Config, 'url'>): string;
    getShareLink(provider: typeof Providers.twitter | typeof Providers.linkedin | typeof Providers.vkontakte | typeof Providers.telegram | typeof Providers.getpocket | typeof Providers.evernote | typeof Providers.pinterest | typeof Providers.skype | typeof Providers.whatsapp | typeof Providers.xing, config?: Pick<Config, 'url' | 'title'>): string;
    getShareLink(provider: typeof Providers.mailto, config?: Config): string;
}
